/* $Id: del_all_jobs.c 533 2007-12-22 15:25:42Z lukasz $ */
/*
 *  FedStage DRMAA for PBS Pro
 *  Copyright (C) 2006-2007  Fedstage Systems Inc.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <pbs_ifl.h>

int
main( int argc, char **argv )
{
	const char *contact = NULL;
	int conn = -1;
	if( argc>1 )
		contact = argv[1];
	conn = pbs_connect( (char*)contact );
	if( conn != -1 )
	 {
		struct batch_status *status = NULL, *i;
		struct attrl attribs[1];
		attribs[0].name = "jobstate";
		attribs[0].resource = NULL;
		attribs[0].value = NULL;
		attribs[0].next = NULL;

		status = pbs_statjob( conn, NULL, NULL, NULL );
		/* printf( "here status=%p\n", (void*)status ); */
		for( i = status;  i != NULL;  i = i->next )
		 {
			printf( "deleting job %s\n", i->name );
			pbs_deljob( conn, i->name, NULL );
		 }

		if( status )
			pbs_statfree( status );
	 }

	if( conn != -1 )
		pbs_disconnect( conn );
	return 0;
}
