#!/usr/bin/env python
# -*- coding: utf-8 -*-

from distutils.core import setup
from distutils.extension import Extension
from Pyrex.Distutils import build_ext
import os.path

BASE = os.path.dirname( __file__ )
def p( path ):
	return os.path.join(*( [BASE] + path.split("/") ))

setup(
	name = "PyDRMAA",
	version = "0.1",
	author = u"Łukasz Cieśnik".encode("utf-8"),
	author_email = "lukasz.ciesnik@gmail.com",
	url="http://www.fedstage.com/wiki/FedStage_DRMAA_for_PBS",
	download_url="http://sourceforge.net/projects/pbs-drmaa",
	license="GNU Lesser General Public License (LGPL)",
	description = "Python languge bindings and testsuite for DRMAA 1.0 C library",
	long_description = open(p("README"),"rb").read(),
	keywords = ["drmaa", "bindings", "testsuite"],
	classifiers = [
		"Development Status :: 3 - Alpha",
		"Intended Audience :: Developers",
		"License :: OSI Approved :: GNU Lesser General Public License (LGPL)",
		"Operating System :: OS Independent",
		"Programming Language :: Python",
		"Topic :: System :: Distributed Computing",
		"Topic :: Software Development :: Testing",
		"Topic :: Software Development :: Libraries :: Python Modules",
	],

	package_dir = {"": BASE},
	packages = ["drmaa", "drmaa.testsuite", "testing"],
	ext_modules = [ 
		Extension( "drmaa.core", [p("drmaa/drmaa.core.pyx")],
				libraries = ["drmaa"] ),
		Extension( "drmaa.pbs_drmaa", [p("drmaa/drmaa.pbs_drmaa.pyx")],
				libraries = ["drmaa"] ),
		Extension( "testing.utils", [p("testing/testing.utils.pyx")] ),
		],

	cmdclass = {"build_ext": build_ext},
)

